import es
import gamethread
import langlib
import playerlib
import popuplib
import random

def load():
	load_variables()
	create_popup()

def es_map_start(event_var):
	load_variables()

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			if event_var["es_userteam"] > 1:
				check = es.ServerVar("sm_cap_fight_frozen")
				if check == 0:
					type = es.ServerVar("sm_cap_fight_type")
					if type == "hegrenade":
						cmd = "es_xgive %s %s" % (event_var["userid"], "weapon_hegrenade")
						es.server.queuecmd(cmd)
					elif type == "weapon_1":
						weapon = es.ServerVar("sm_cap_weapon_1")
						cmd = "es_xgive %s weapon_%s" % (event_var["userid"], weapon)
						es.server.queuecmd(cmd)
					elif type == "weapon_2":
						weapon = es.ServerVar("sm_cap_weapon_2")
						cmd = "es_xgive %s weapon_%s" % (event_var["userid"], weapon)
						es.server.queuecmd(cmd)
					elif type == "weapon_3":
						weapon = es.ServerVar("sm_cap_weapon_3")
						cmd = "es_xgive %s weapon_%s" % (event_var["userid"], weapon)
						es.server.queuecmd(cmd)
					elif type == "high_speed":
						cmd = "playerset speed %s 2" % (event_var["userid"])
						es.server.queuecmd(cmd)
				else:
					cmd = "playerset freeze %s 1" % (event_var["userid"])
					es.server.queuecmd(cmd)

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			load_variables()

def hegrenade_detonate(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			check = es.ServerVar("sm_cap_fight_frozen")
			if check == 0:
				type = es.ServerVar("sm_cap_fight_type")
				if type == "hegrenade":
					temp_string = "playerget isdead is_dead %s" % (event_var["userid"])
					es.server.queuecmd(temp_string)
					check = es.ServerVar("is_dead")
					if check == 0:
						temp_string = "playerget he he_number %s" % (event_var["userid"])
						es.server.queuecmd(temp_string)
						check = es.ServerVar("he_number")
						if check == 0:
							cmd = "es_xgive %s %s" % (event_var["userid"], "weapon_hegrenade")
							es.server.queuecmd(cmd)

def round_end(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 1:
			load_variables()

def load_variables():
	es.set("cap_fight", 0)
	es.set("sm_cap_fight_frozen", 0)
	es.set("sm_cap_fight_type", 0)

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/cap/popup_admin_cap_fights.ini")

	popup = popuplib.create("sm_popup_admin_cap_fights")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	line = "->1. %s" % (text("knife"))
	popup.addline(line)

	line = "->2. %s" % (text("hegrenade"))
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_1")
	tokens = {}
	tokens['weapon'] = value
	line = "->3. %s" % (text("weapon", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_2")
	tokens = {}
	tokens['weapon'] = value
	line = "->4. %s" % (text("weapon", tokens))
	popup.addline(line)

	value = es.ServerVar("sm_cap_weapon_3")
	tokens = {}
	tokens['weapon'] = value
	line = "->5. %s" % (text("weapon", tokens))
	popup.addline(line)

	line = "->6. %s" % (text("high_speed"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, freeze)
	popup.select(2, freeze)
	popup.select(3, freeze)
	popup.select(4, freeze)
	popup.select(5, freeze)
	popup.select(6, freeze)
	popup.submenu(7, "sm_popup_admin_cap_fights")
	popup.submenu(8, "sm_popup_admin_cap_fights")
	popup.submenu(9, "sm_popup_admin_cap")

def freeze(userid, choice, popupid):
	check = es.ServerVar("match")
	if check == 0:
		check = es.ServerVar("cap_fight")
		if check == 0:
			players = es.getUseridList()
			for player in players:
				cmd = "playerset freeze %s 1" % (player)
				es.server.queuecmd(cmd)

			es.set("cap_fight", 1)
			es.set("sm_cap_fight_type", 0)
			es.set("sm_cap_fight_frozen", 1)

			es.set("sm_cap_fight_weapon", 0)

			name = es.getplayername(userid)
			if choice == 1:
				es.set("sm_cap_fight_type", "knife")

				hudhint = "Caps get ready for a knife fight!"
				message = "%s has started a knife fight." % (name)
			elif choice == 2:
				es.set("sm_cap_fight_type", "hegrenade")
				es.set("sm_cap_fight_weapon", "weapon_hegrenade")

				hudhint = "Caps get ready for a hegrenade fight!"
				message = "%s has started a hegrenade fight." % (name)
			elif choice == 3:
				es.set("sm_cap_fight_type", "weapon_1")
				value = es.ServerVar("sm_cap_weapon_1")
				weapon = "weapon_%s" % (value)
				es.set("sm_cap_fight_weapon", weapon)

				hudhint = "Caps get ready for a %s fight!" % (value)
				message = "%s has started a %s fight." % (name, value)
			elif choice == 4:
				es.set("sm_cap_fight_type", "weapon_2")
				value = es.ServerVar("sm_cap_weapon_2")
				weapon = "weapon_%s" % (value)
				es.set("sm_cap_fight_weapon", weapon)

				hudhint = "Caps get ready for a %s fight!" % (value)
				message = "%s has started a %s fight." % (name, value)
			elif choice == 5:
				es.set("sm_cap_fight_type", "weapon_3")
				value = es.ServerVar("sm_cap_weapon_3")
				weapon = "weapon_%s" % (value)
				es.set("sm_cap_fight_weapon", weapon)

				hudhint = "Caps get ready for a %s fight!" % (value)
				message = "%s has started a %s fight." % (name, value)
			elif choice == 6:
				es.set("sm_cap_fight_type", "high_speed")

				hudhint = "Caps get ready for a high speed fight!"
				message = "%s has started a high speed fight." % (name)

			myPlayerList = playerlib.getPlayerList("#human")
			for ply in myPlayerList:
				cmd = 'usermsg hudhint %s "%s"' % (ply.userid, hudhint)
				es.server.queuecmd(cmd)

			es.msg("#green", message)

			show_centermsg("| PREPARE TO FIGHT! |")
			gamethread.delayed(1, show_centermsg, ("| PREPARE TO FIGHT! |"))
			gamethread.delayed(2, show_centermsg, ("| 3 |"))
			gamethread.delayed(3, show_centermsg, ("| 2 |"))
			gamethread.delayed(4, show_centermsg, ("| 1 |"))
			gamethread.delayed(5, show_centermsg, ("| FIGHT! |"))

			gamethread.delayed(5, start, (choice))
		else:
			es.tell(userid, "#green", "Cap fight already started.")
	else:
		es.tell(userid, "#green", "You can not start a cap fight during a match.")

	popuplib.send("sm_popup_admin_cap_fights", userid)

def show_centermsg(message):
	es.centermsg(message)

def start(choice):
	check = es.ServerVar("cap_fight")
	if check == 1:
		es.set("sm_cap_fight_frozen", 0)

		weapon = es.ServerVar("sm_cap_fight_weapon")
		players = es.getUseridList()
		for player in players:
			cmd = "playerset freeze %s 0" % (player)
			es.server.queuecmd(cmd)

			player = playerlib.getPlayer(player)
			player.godmode(0)

			cmd = "playerset health %s 100" % (player)
			es.server.queuecmd(cmd)
			if weapon != "0":
				cmd = "es_xgive %s %s" % (player, weapon)
				es.server.queuecmd(cmd)
			else:
				check = es.ServerVar("sm_cap_fight_type")
				if check == "high_speed":
					players = es.getUseridList()
					for player in players:
						cmd = "playerset speed %s 2" % (player)
						es.server.queuecmd(cmd)

def delete_popup():
	if popuplib.exists("sm_popup_admin_cap_fights"):
		popuplib.delete("sm_popup_admin_cap_fights")

def unload():
	delete_popup()