import datetime
import es
import gamethread
import keymenulib
import math
import playerlib
import popuplib
import random
import sqlite3
import time

connection = sqlite3.connect("cstrike/cfg/soccer_mod/players.sqldb")
cursor = connection.cursor()

rank_goal = 25
rank_assist = 10
rank_own_goal = -25
rank_hit = 1
rank_pass = 5
rank_interception = 2
rank_lose = -2

shooter_time_stamp = 0
assister_time_stamp = 0

def load():
	es.set("sm_stats_debug", 0)
	load_variables()
	reset_team_stats()
	create_popup()
	create_popup_ranking()

	value = random.randint(1, 99999)
	cmd = "sm_event_stats_%s" % (value)
	es.set("sm_event_stats", cmd)
	es.regclientcmd(cmd, "soccer_mod_2010/match/stats/ball_hit", "Ball hit")

	es.keygroupcreate("soccer_mod_stats")

	es.load("soccer_mod_2010/match/stats/score_sheet")

def es_map_start(event_var):
	connection.commit()

	reset_team_stats()
	delete_keygroup()
	es.keygroupcreate("soccer_mod_stats")

def player_activate(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		set_connected(event_var["es_username"], event_var["es_steamid"], event_var["userid"])

def player_disconnect(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		set_connected(event_var["es_username"], event_var["es_steamid"], event_var["userid"])

def round_start(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		es.set("sm_match_first_hit", 1)
		es.set("sm_stats_round_end", 0)

		load_variables()

		players = es.getUseridList()
		length = len(players)
		if length > 0:
			length -= 1
			value = random.randint(0, length)
			userid = players[value]

			es.give(userid, "point_clientcommand")
			event = es.ServerVar("sm_event_stats")
			cmd = 'es_xfire %s func_physbox addoutput "OnDamaged point_clientcommand,command,%s"' % (userid, event)
			es.server.queuecmd(cmd)

def round_end(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		gamethread.delayed(0.15, show_stats, (int(event_var["winner"])))

def set_connected(name, steamid, userid):
	if steamid != "BOT":
		current = datetime.datetime.now()

		if current.month < 10:
			month = "0%s" % (current.month)
		else:
			month = current.month

		if current.day < 10:
			day = "0%s" % (current.day)
		else:
			day = current.day

		if current.hour < 10:
			hour = "0%s" % (current.hour)
		else:
			hour = current.hour

		if current.minute < 10:
			minute = "0%s" % (current.minute)
		else:
			minute = current.minute

		if current.second < 10:
			second = "0%s" % (current.second)
		else:
			second = current.second

		date = "%s-%s-%s %s:%s:%s" % (current.year, month, day, hour, minute, second)

		query = "SELECT steamid FROM players WHERE steamid = '%s'" % (steamid)
		cursor.execute(query)

		check = 0
		for row in cursor:
			check += 1

		if check > 0:
			query = "UPDATE players SET name = '%s', connected = '%s' WHERE steamid = '%s'" % (name, date, steamid)
			cursor.execute(query)
		else:
			query = "INSERT INTO players (name, steamid, connected) VALUES ('%s', '%s', '%s')" % (name, steamid, date)
			cursor.execute(query)

def load_variables():
	es.set("sm_stats_shooter_userid", 0)
	es.set("sm_stats_shooter_name", 0)
	es.set("sm_stats_shooter_team", 0)
	es.set("sm_stats_shooter_steamid", 0)

	global shooter_time_stamp
	shooter_time_stamp = 0

	es.set("sm_stats_assister_userid", 0)
	es.set("sm_stats_assister_name", 0)
	es.set("sm_stats_assister_team", 0)
	es.set("sm_stats_assister_steamid", 0)

	global assister_time_stamp
	assister_time_stamp = 0

	es.set("sm_stats_winner", 0)

def ball_hit():
	end = es.ServerVar("sm_stats_round_end")
	paused = es.ServerVar("match_paused")
	period_break = es.ServerVar("period_break_running")
	if end == 0 and paused == 0 and period_break == 0:
		es.set("sm_match_first_hit", 0)

		userid = int(es.getcmduserid())
		steamid = es.getplayersteamid(userid)
		team = int(es.getplayerteam(userid))
		name = es.getplayername(userid)

		exists = es.exists("key", "soccer_mod_stats", steamid)
		if exists == 0:
			es.keycreate("soccer_mod_stats", steamid)
			es.keysetvalue("soccer_mod_stats", steamid, "possession", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "goals", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "assists", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "own_goals", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "hits", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "passes", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "interceptions", 0)
			es.keysetvalue("soccer_mod_stats", steamid, "losses", 0)

		debug = es.ServerVar("sm_stats_debug")
		if debug == 1:
			message = "%s has hit the ball." % (name)
			es.msg("#green", message)

		add_stat(steamid, team, "hits", rank_hit)

		shooter_userid = int(es.ServerVar("sm_stats_shooter_userid"))
		shooter_steamid = es.ServerVar("sm_stats_shooter_steamid")
		shooter_team = int(es.ServerVar("sm_stats_shooter_team"))
		shooter_name = es.ServerVar("sm_stats_shooter_name")

		if userid != shooter_userid:
			es.set("sm_stats_assister_userid", shooter_userid)
			es.set("sm_stats_assister_steamid", shooter_steamid)
			es.set("sm_stats_assister_team", shooter_team)
			es.set("sm_stats_assister_name", shooter_name)

			es.set("sm_stats_shooter_userid", userid)
			es.set("sm_stats_shooter_steamid", steamid)
			es.set("sm_stats_shooter_team", team)
			es.set("sm_stats_shooter_name", name)

			global shooter_time_stamp
			global assister_time_stamp
			assister_time_stamp = shooter_time_stamp
			shooter_time_stamp = time.time()

			if shooter_userid > 0:
				if team == shooter_team:
					if debug == 1:
						message = "%s has passed the ball to %s." % (shooter_name, name)
						es.msg("#green", message)

					add_stat(shooter_steamid, shooter_team, "passes", rank_pass)
				else:
					if debug == 1:
						message = "%s has intercepted the ball from %s." % (name, shooter_name)
						es.msg("#green", message)

					add_stat(steamid, team, "interceptions", rank_interception)

					if debug == 1:
						message = "%s has lost the ball to %s." % (shooter_name, name)
						es.msg("#green", message)

					add_stat(shooter_steamid, shooter_team, "losses", rank_loss)

				possession = int(shooter_time_stamp - assister_time_stamp)

				if possession > 0:

					if debug == 1:
						message = "%s had the ball for %s seconds." % (shooter_name, possession)
						es.msg("#green", message)

					add_possession(shooter_steamid, shooter_team, possession)

def show_stats(winner):
	es.set("sm_match_first_hit", 1)
	es.set("sm_stats_round_end", 1)
	es.set("sm_stats_winner", winner)

	shooter_userid = int(es.ServerVar("sm_stats_shooter_userid"))
	shooter_team = int(es.ServerVar("sm_stats_shooter_team"))
	shooter_steamid = es.ServerVar("sm_stats_shooter_steamid")
	shooter_name = es.ServerVar("sm_stats_shooter_name")

	assister_userid = int(es.ServerVar("sm_stats_assister_userid"))
	assister_team = int(es.ServerVar("sm_stats_assister_team"))
	assister_steamid = es.ServerVar("sm_stats_assister_steamid")
	assister_name = es.ServerVar("sm_stats_assister_name")

	if shooter_userid > 0:
		current = time.time()
		global shooter_time_stamp
		possession = int(current - shooter_time_stamp)

		if possession > 0:
			add_possession(shooter_steamid, shooter_team, possession)

		if shooter_team == winner:
			message = "Goal scored by %s" % (shooter_name)
			es.msg("#green", message)

			add_stat(shooter_steamid, shooter_team, "goals", rank_goal)

			if assister_team == winner:
				message = "Assisted by %s" % (assister_name)
				es.msg("#green", message)

				add_stat(assister_steamid, assister_team, "assists", rank_assist)
		else:
			message = "Own goal scored by %s" % (shooter_name)
			es.msg("#green", message)

			add_stat(shooter_steamid, shooter_team, "own_goals", rank_own_goal)

		es.doblock("soccer_mod_2010/match/stats/score_sheet/add")

	load_variables()

def add_stat(steamid, team, type, points):
	if team == 2:
		name = "sm_stats_number_%s_t" % (type)
		value = es.ServerVar(name)
		value += 1
		es.set(name, value)
	elif team == 3:
		name = "sm_stats_number_%s_ct" % (type)
		value = es.ServerVar(name)
		value += 1
		es.set(name, value)

	value = int(es.keygetvalue("soccer_mod_stats", steamid, type))
	value += 1
	es.keysetvalue("soccer_mod_stats", steamid, type, value)

	query = "UPDATE players SET %s = (%s + 1), rank = (rank + %s) WHERE steamid = '%s'" % (type, type, points, steamid)
	cursor.execute(query)

def add_possession(steamid, team, possession):
	if team == 2:
		value = es.ServerVar("sm_stats_pos_t")
		value += possession
		es.set("sm_stats_pos_t", value)
	elif team == 3:
		value = es.ServerVar("sm_stats_pos_ct")
		value += possession
		es.set("sm_stats_pos_ct", value)

	value = es.ServerVar("sm_stats_total_pos")
	value += possession
	es.set("sm_stats_total_pos", value)

	value = int(es.keygetvalue("soccer_mod_stats", steamid, "possession"))
	value += possession
	es.keysetvalue("soccer_mod_stats", steamid, "possession", value)

def reset_team_stats():
	es.set("sm_stats_pos_t", 0)
	es.set("sm_stats_pos_ct", 0)
	es.set("sm_stats_total_pos", 0)

	es.set("sm_stats_number_goals_t", 0)
	es.set("sm_stats_number_goals_ct", 0)

	es.set("sm_stats_number_assists_t", 0)
	es.set("sm_stats_number_assists_ct", 0)

	es.set("sm_stats_number_own_goals_t", 0)
	es.set("sm_stats_number_own_goals_ct", 0)

	es.set("sm_stats_number_hits_t", 0)
	es.set("sm_stats_number_hits_ct", 0)

	es.set("sm_stats_number_passes_t", 0)
	es.set("sm_stats_number_passes_ct", 0)

	es.set("sm_stats_number_interceptions_t", 0)
	es.set("sm_stats_number_interceptions_ct", 0)

	es.set("sm_stats_number_losses_t", 0)
	es.set("sm_stats_number_losses_ct", 0)

def create_popup():
	popup = popuplib.create("sm_popup_stats")
	popup.addline("SOCCER MOD STATS")
	popup.addline(" ")
	popup.addline("->1. Team")
	popup.addline("->2. Personal")
	popup.addline("->3. Player")
	popup.addline("->4. Rankings")
	popup.addline("->5. Score sheet")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(1, team)
	popup.select(2, personal)
	popup.select(3, player)
	popup.select(4, ranking)
	popup.select(5, score_sheet)
	popup.submenu(6, "sm_popup_stats")
	popup.submenu(7, "sm_popup_stats")
	popup.submenu(8, "sm_popup_stats")
	popup.submenu(9, "sm_popup_stats")

def cmd_stats():
	userid = es.getcmduserid()

	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		popuplib.send("sm_popup_stats", userid)
	else:
		es.tell(userid, "#green", "Soccer Mod is not allowed on this map.")

def cmd_stats_rank():
	userid = es.getcmduserid()
	steamid = es.getplayersteamid(userid)

	query = "SELECT steamid FROM players WHERE rank > 0 ORDER BY rank desc, name asc"
	cursor.execute(query)
	number = 0
	rank = 0
	stop = 0
	for row in cursor:
		number += 1
		if stop == 0:
			rank += 1
			if row[0] == steamid:
				stop = 1

	message = "You are ranked %s out of %s players in total." % (rank, number)
	es.tell(userid, "#green", message)

def team(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)
	popup.addline("SOCCER MOD TEAM STATS")
	popup.addline(" ")

	value = es.ServerVar("sm_match_name_t")
	line = "%s:" % (value)
	popup.addline(line)

	popup.addline(" ")

	symbol = "%"
	possession = float(es.ServerVar("sm_stats_total_pos"))
	if possession > 0:
		value = float(es.ServerVar("sm_stats_pos_t"))
		percentage = int(round(((value / possession) * 100), 0))
	else:
		percentage = int(0)

	line = "Possession: %s%s" % (percentage, symbol)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_goals_t")
	line = "Goals: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_assists_t")
	line = "Assists: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_own_goals_t")
	line = "Own goals: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_hits_t")
	line = "Hits: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_passes_t")
	line = "Passes: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_interceptions_t")
	line = "Interceptions: %s" % (value)
	popup.addline(line)

	popup.addline(" ")

	value = es.ServerVar("sm_match_name_ct")
	line = "%s:" % (value)
	popup.addline(line)

	popup.addline(" ")

	symbol = "%"
	possession = float(es.ServerVar("sm_stats_total_pos"))
	if possession > 0:
		value = float(es.ServerVar("sm_stats_pos_ct"))
		percentage = int(round((value / possession) * 100))
	else:
		percentage = int(0)

	line = "Possession: %s%s" % (percentage, symbol)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_goals_ct")
	line = "Goals: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_assists_ct")
	line = "Assists: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_own_goals_ct")
	line = "Own goals: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_hits_ct")
	line = "Hits: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_passes_ct")
	line = "Passes: %s" % (value)
	popup.addline(line)

	value = es.ServerVar("sm_stats_number_interceptions_ct")
	line = "Interceptions: %s" % (value)
	popup.addline(line)

	popup.addline(" ")
	popup.addline("->9. Back")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(1, team)
	popup.select(2, team)
	popup.select(3, team)
	popup.select(4, team)
	popup.select(5, team)
	popup.select(6, team)
	popup.select(7, team)
	popup.select(8, team)
	popup.select(9, back)

	popuplib.send(name, userid)

def personal(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	exists = es.exists("key", "soccer_mod_stats", steamid)
	if exists == 1:
		name = "sm_popup_%s" % (userid)
		if popuplib.exists(name):
			popuplib.delete(name)

		popup = popuplib.create(name)
		popup.addline("SOCCER MOD CURRENT PERSONAL STATS")
		popup.addline(" ")

		symbol = "%"
		possession = float(es.ServerVar("sm_stats_total_pos"))
		if possession > 0:
			value = float(es.keygetvalue("soccer_mod_stats", steamid, "possession"))
			percentage = int(round(((value / possession) * 100), 0))
		else:
			percentage = int(0)

		line = "Possession: %s%s" % (percentage, symbol)
		popup.addline(line)

		stats = ["goals", "assists", "own_goals", "hits", "passes", "interceptions", "losses"]
		stats_names = ["Goals", "Assists", "Own goals", "Hits", "Passes", "Interceptions", "Ball losses"]
		count = 0
		for stat in stats:
			value = float(es.keygetvalue("soccer_mod_stats", steamid, stats[count]))
			string = "sm_stats_number_%s_t" % (stats[count])
			value_t = float(es.ServerVar(string))
			string = "sm_stats_number_%s_ct" % (stats[count])
			value_ct = float(es.ServerVar(string))
			total = value_t + value_ct
			if total > 0:
				percentage = value / total
				percentage *= 100
				number = round(percentage, 0)
				percentage = int(number)
			else:
				percentage = 0

			value = int(value)
			total = int(total)

			line = "%s: %s / %s (%s%s)" % (stats_names[count], value, total, percentage, symbol)
			popup.addline(line)
			count += 1
			
		popup.addline(" ")
		popup.addline("->9. Back")
		popup.addline(" ")
		popup.addline("0. Close")
		popup.select(1, personal)
		popup.select(2, personal)
		popup.select(3, personal)
		popup.select(4, personal)
		popup.select(5, personal)
		popup.select(6, personal)
		popup.select(7, personal)
		popup.select(8, personal)
		popup.select(9, back)

		popuplib.send(name, userid)
	else:
		es.tell(userid, "#green", "No stats recorded.")
		popuplib.send("sm_popup_stats", userid)

def player(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	source_tv = es.ServerVar("tv_name")

	es.keygroupcreate("playerlist")

	myPlayerList = playerlib.getPlayerList("#all")
	for ply in myPlayerList:
		if ply.name != source_tv:
			es.keycreate("playerlist", ply.userid)
			es.keysetvalue("playerlist", ply.userid, "name", ply.name)

	keymenu = keymenulib.create(name, "target", player_choice, "playerlist", "#keyvalue name", "#key", "Select a player")
	keymenu.backmenu("sm_popup_stats")
	keymenulib.send(name, userid)

	es.keygroupdelete("playerlist")

def player_choice(userid, choice, keymenuname):
	steamid = es.getplayersteamid(choice)
	exists = es.exists("key", "soccer_mod_stats", steamid)
	if exists == 1:
		name = "sm_popup_%s" % (userid)
		if popuplib.exists(name):
			popuplib.delete(name)

		popup = popuplib.create(name)
		popup.addline("SOCCER MOD CURRENT PLAYER STATS")
		popup.addline(" ")

		player_name = es.getplayername(choice)
		line = "%s:" % (player_name)
		popup.addline(line)
		popup.addline(" ")

		symbol = "%"
		possession = float(es.ServerVar("sm_stats_total_pos"))
		if possession > 0:
			value = float(es.keygetvalue("soccer_mod_stats", steamid, "possession"))
			percentage = int(round(((value / possession) * 100), 0))
		else:
			percentage = int(0)

		line = "Possession: %s%s" % (percentage, symbol)
		popup.addline(line)

		stats = ["goals", "assists", "own_goals", "hits", "passes", "interceptions", "losses"]
		stats_names = ["Goals", "Assists", "Own goals", "Hits", "Passes", "Interceptions", "Ball losses"]
		count = 0
		for stat in stats:
			value = float(es.keygetvalue("soccer_mod_stats", steamid, stats[count]))
			string = "sm_stats_number_%s_t" % (stats[count])
			value_t = float(es.ServerVar(string))
			string = "sm_stats_number_%s_ct" % (stats[count])
			value_ct = float(es.ServerVar(string))
			total = value_t + value_ct
			if total > 0:
				percentage = value / total
				percentage *= 100
				number = round(percentage, 0)
				percentage = int(number)
			else:
				percentage = 0

			value = int(value)
			total = int(total)

			line = "%s: %s / %s (%s%s)" % (stats_names[count], value, total, percentage, symbol)
			popup.addline(line)
			count += 1
			
		popup.addline(" ")
		popup.addline("->9. Back")
		popup.addline(" ")
		popup.addline("0. Close")
		popup.select(9, back)

		popuplib.send(name, userid)
	else:
		es.tell(userid, "#green", "No stats recorded.")
		popuplib.send("sm_popup_stats", userid)

def ranking(userid, choice, popupid):
	popuplib.send("sm_popup_stats_ranking", userid)

def create_popup_ranking():
	popup = popuplib.create("sm_popup_stats_ranking")
	popup.addline("SOCCER MOD STATS RANKINGS")
	popup.addline(" ")
	popup.addline("->1. Total")
	popup.addline("->2. Goals")
	popup.addline("->3. Assists")
	popup.addline("->4. Own goals")
	popup.addline("->5. Hits")
	popup.addline("->6. Passes")
	popup.addline("->7. Interceptions")
	popup.addline("->8. Personal")
	popup.addline(" ")
	popup.addline("->9. Back")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(1, create_ranking)
	popup.select(2, create_ranking)
	popup.select(3, create_ranking)
	popup.select(4, create_ranking)
	popup.select(5, create_ranking)
	popup.select(6, create_ranking)
	popup.select(7, create_ranking)
	popup.select(8, all_time_personal)
	popup.select(9, back)

def create_ranking(userid, choice, popupid):
	if choice == 1:
		type = "rank"
		title = "Total ranking"
	elif choice == 2:
		type = "goals"
		title = "Goal ranking"
	elif choice == 3:
		type = "assists"
		title = "Assists ranking"
	elif choice == 4:
		type = "own_goals"
		title = "Own goal ranking"
	elif choice == 5:
		type = "hits"
		title = "Hit ranking"
	elif choice == 6:
		type = "passes"
		title = "Pass ranking"
	elif choice == 7:
		type = "interceptions"
		title = "Interception ranking"

	es.set("target", 0)
	query_count = "SELECT steamid FROM players WHERE %s > 0" % (type)
	query = "SELECT name, steamid, %s FROM players WHERE %s > 0 ORDER BY %s desc, name asc" % (type, type, type)
	name = "sm_popup_%s" % (userid)
	create_popup_menu(name, title, query_count, query, 0, 1, 0, type)
	popuplib.send(name, userid)

def rank_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE rank > 0"
		query = "SELECT name, steamid, rank FROM players WHERE rank > 0 ORDER BY rank desc, name asc"
		create_popup_menu(name, "Total ranking", query_count, query, 0, 1, result, "rank")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE rank > 0"
		query = "SELECT name, steamid, rank FROM players WHERE rank > 0 ORDER BY rank desc, name asc"
		create_popup_menu(name, "Total ranking", query_count, query, 0, 1, result, "rank")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def goals_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE goals > 0"
		query = "SELECT name, steamid, goals FROM players WHERE goals > 0 ORDER BY goals desc, name asc"
		create_popup_menu(name, "Goal ranking", query_count, query, 0, 1, result, "goals")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE goals > 0"
		query = "SELECT name, steamid, goals FROM players WHERE goals > 0 ORDER BY goals desc, name asc"
		create_popup_menu(name, "Goal ranking", query_count, query, 0, 1, result, "goals")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def assists_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE assists > 0"
		query = "SELECT name, steamid, assists FROM players WHERE assists > 0 ORDER BY assists desc, name asc"
		create_popup_menu(name, "Assist ranking", query_count, query, 0, 1, result, "assists")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE assists > 0"
		query = "SELECT name, steamid, assists FROM players WHERE assists > 0 ORDER BY assists desc, name asc"
		create_popup_menu(name, "Assist ranking", query_count, query, 0, 1, result, "assists")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def own_goals_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE own_goals > 0"
		query = "SELECT name, steamid, own_goals FROM players WHERE own_goals > 0 ORDER BY own_goals desc, name asc"
		create_popup_menu(name, "Own goal ranking", query_count, query, 0, 1, result, "own_goals")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE own_goals > 0"
		query = "SELECT name, steamid, own_goals FROM players WHERE own_goals > 0 ORDER BY own_goals desc, name asc"
		create_popup_menu(name, "Own goal ranking", query_count, query, 0, 1, result, "own_goals")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def hits_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE hits > 0"
		query = "SELECT name, steamid, hits FROM players WHERE hits > 0 ORDER BY hits desc, name asc"
		create_popup_menu(name, "Hit ranking", query_count, query, 0, 1, result, "hits")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE hits > 0"
		query = "SELECT name, steamid, hits FROM players WHERE hits > 0 ORDER BY hits desc, name asc"
		create_popup_menu(name, "Hit ranking", query_count, query, 0, 1, result, "hits")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def passes_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE passes > 0"
		query = "SELECT name, steamid, passes FROM players WHERE passes > 0 ORDER BY passes desc, name asc"
		create_popup_menu(name, "Pass ranking", query_count, query, 0, 1, result, "passes")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE passes > 0"
		query = "SELECT name, steamid, passes FROM players WHERE passes > 0 ORDER BY passes desc, name asc"
		create_popup_menu(name, "Pass ranking", query_count, query, 0, 1, result, "passes")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def interceptions_choice(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	target = es.ServerVar("target")
	if target != "0":
		create_popup_player(userid, target)
	elif choice == 8:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE interceptions > 0"
		query = "SELECT name, steamid, interceptions FROM players WHERE interceptions > 0 ORDER BY interceptions desc, name asc"
		create_popup_menu(name, "Interception ranking", query_count, query, 0, 1, result, "interceptions")
		popuplib.send(name, userid)
	elif choice == 9:
		result = es.ServerVar("result")
		es.set("target", 0)
		query_count = "SELECT steamid FROM players WHERE interceptions > 0"
		query = "SELECT name, steamid, interceptions FROM players WHERE interceptions > 0 ORDER BY interceptions desc, name asc"
		create_popup_menu(name, "Interception ranking", query_count, query, 0, 1, result, "interceptions")
		popuplib.send(name, userid)
	elif choice == 10:
		if popuplib.exists(name):
			popuplib.delete(name)
		popuplib.send("sm_popup_stats_ranking", userid)
	elif target == "0":
		popuplib.send(name, userid)

def all_time_personal(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)
	popup.addline("SOCCER MOD ALL TIME PERSONAL STATS")
	popup.addline(" ")

	steamid = es.getplayersteamid(userid)
	
	query = "SELECT goals, assists, own_goals, hits, passes, interceptions, rank FROM players WHERE steamid = '%s'" % (steamid)
	cursor.execute(query)
	for row in cursor:
		line = "Ranking points: %s" % (row[6])
		popup.addline(line)

		line = "Goals: %s" % (row[0])
		popup.addline(line)

		line = "Assists: %s" % (row[1])
		popup.addline(line)

		line = "Own goals: %s" % (row[2])
		popup.addline(line)

		line = "Hits: %s" % (row[3])
		popup.addline(line)

		line = "Passes: %s" % (row[4])
		popup.addline(line)

		line = "Interceptions: %s" % (row[5])
		popup.addline(line)

	popup.addline(" ")
	popup.addline("->9. Back")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(1, all_time_personal)
	popup.select(2, all_time_personal)
	popup.select(3, all_time_personal)
	popup.select(4, all_time_personal)
	popup.select(5, all_time_personal)
	popup.select(6, all_time_personal)
	popup.select(7, all_time_personal)
	popup.select(8, all_time_personal)
	popup.select(9, ranking_back)

	popuplib.send(name, userid)

def create_popup_player(userid, steamid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)
	popup.addline("SOCCER MOD ALL TIME PLAYER STATS")
	popup.addline(" ")

	query = "SELECT name, goals, assists, own_goals, hits, passes, interceptions, rank, connected FROM players WHERE steamid = '%s'" % (steamid)
	cursor.execute(query)
	for row in cursor:
		line = "%s:" % (row[0])
		popup.addline(line)

		popup.addline(" ")

		line = "Last connected: %s" % (row[8])
		popup.addline(line)

		line = "Ranking points: %s" % (row[7])
		popup.addline(line)

		line = "Goals: %s" % (row[1])
		popup.addline(line)

		line = "Assists: %s" % (row[2])
		popup.addline(line)

		line = "Own goals: %s" % (row[3])
		popup.addline(line)

		line = "Hits: %s" % (row[4])
		popup.addline(line)

		line = "Passes: %s" % (row[5])
		popup.addline(line)

		line = "Interceptions: %s" % (row[6])
		popup.addline(line)

	popup.addline(" ")
	popup.addline("->9. Back")
	popup.addline(" ")
	popup.addline("0. Close")
	popup.select(9, ranking_back)

	popuplib.send(name, userid)

def ranking_back(userid, choice, popupid):
	popuplib.send("sm_popup_stats_ranking", userid)

def score_sheet(userid, choice, popupid):
	check = es.ServerVar("sm_stats_score_sheet_number")
	if check > 1:
		popuplib.send("sm_popup_stats_score_sheet_1", userid)
	else:
		es.tell(userid, "#green", "Score sheet is empty.")
		popuplib.send("sm_popup_stats", userid)

def back(userid, choice, popupid):
	popuplib.send("sm_popup_stats", userid)

def create_popup_menu(name, title, query_count, query, menu, value, result, block):
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)
	popup.addline(title)
	popup.addline(" ")

	cursor.execute(query_count)

	number = 0
	for row in cursor:
		number += 1

	results = float(number)
	pages = int(math.ceil(results / 7))
	page = (result / 7) + 1

	temp_results = int(results)
	temp_result = result + 1
	temp_result2 = result + 7
	if temp_result2 > temp_results:
		temp_result2 = temp_results

	query_limit = "%s LIMIT %s, 7" % (query, result)
	cursor.execute(query_limit)

	number = 0
	position = temp_result
	for row in cursor:
		number += 1
		line = "->%s. %s %s" % (position, row[2], row[menu])
		popup.addline(line)
		popup.menuvalue("target", number, row[value])
		position += 1

	popup.addline(" ")
	line = "Page %s of %s" % (page, pages)
	popup.addline(line)
	line = "Result %s - %s of %s" % (temp_result, temp_result2, temp_results)
	popup.addline(line)

	if results > 7:
		popup.addline(" ")

	back = result - 7
	if back < 0:
		back = 0
	else:
		popup.addline("->8. Back")

	popup.menuvalue("result", 8, back)

	next = result + 7
	if next >= results:
		next = result
	else:
		popup.addline("->9. Next")

	popup.menuvalue("result", 9, next)

	popup.addline(" ")
	popup.addline("0. Cancel")

	if block == "rank":
		popup.menuselect = rank_choice
	elif block == "goals":
		popup.menuselect = goals_choice
	elif block == "assists":
		popup.menuselect = assists_choice
	elif block == "own_goals":
		popup.menuselect = own_goals_choice
	elif block == "hits":
		popup.menuselect = hits_choice
	elif block == "passes":
		popup.menuselect = passes_choice
	elif block == "interceptions":
		popup.menuselect = interceptions_choice

def delete_keygroup():
	exists = es.exists("keygroup", "soccer_mod_stats")
	if exists == 1:
		es.keygroupdelete("soccer_mod_stats")

def delete_popup():
	if popuplib.exists("sm_popup_stats"):
		popuplib.delete("sm_popup_stats")

def delete_popup_ranking():
	if popuplib.exists("sm_popup_stats_ranking"):
		popuplib.delete("sm_popup_stats_ranking")

def unload():
	connection.commit()
	connection.close()

	delete_keygroup()
	delete_popup()
	delete_popup_ranking()

	cmd = es.ServerVar("sm_event_stats")
	es.unregclientcmd(cmd)

	es.unload("soccer_mod_2010/match/stats/score_sheet")