import es
import gamethread
import playerlib
import random
import re
from spe.games import cstrike

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

def round_start(event_var):
	check = es.ServerVar("soccer_mod_allowed")
	if check == 1:
		players = es.getUseridList()
		length = len(players)
		if length > 0:
			length -= 1
			value = random.randint(0, length)
			userid = players[value]

			cmd = 'es_xfire %s trigger_hurt addoutput "OnStartTouch point_servercommand,command,es_xdoblock soccer_mod_2010/player/disable_god_mode"' % (userid)
			es.server.queuecmd(cmd)

def disable_god_mode():
	myPlayerList = playerlib.getPlayerList("#alive")
	for ply in myPlayerList:
		ply.godmode(0)

def player_spawn(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		team = int(event_var["es_userteam"])
		if team > 1:
			check = es.ServerVar("cap_fight")
			if check == 0:
				player = playerlib.getPlayer(event_var["userid"])
				player.health = 250

				check = es.ServerVar("sm_player_god_mode_on")
				if check == 1:
					player.godmode(1)

			if team == 2:
				model = es.ServerVar("sm_player_model_t")
				temp_string = "playerset model %s %s" % (event_var["userid"], model)
				es.server.cmd(temp_string)
			elif team == 3:
				model = es.ServerVar("sm_player_model_ct")
				temp_string = "playerset model %s %s" % (event_var["userid"], model)
				es.server.cmd(temp_string)

def player_hurt(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		check = es.ServerVar("cap_fight")
		if check == 0:
			enabled = es.ServerVar("sm_player_god_mode_on")
			if enabled == 0:
				player = playerlib.getPlayer(event_var["userid"])
				player.health = 250

		check = es.ServerVar("sm_player_hurt_sounds_on")
		if check == 1:
			length = len(hurt_sounds) - 1
			sound = random.randint(0, length)
			es.emitsound("player", event_var["userid"], hurt_sounds[sound], "1.0", "1.0")

def player_death(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		delay = es.ServerVar("sm_player_respawn_length")
		gamethread.delayed(delay, respawn, (event_var['userid']))

def player_team(event_var):
	enabled = es.ServerVar("soccer_mod_allowed")
	if enabled == 1:
		delay = es.ServerVar("sm_player_respawn_length")
		gamethread.delayed(delay, respawn, (event_var['userid']))

def respawn(userid):
	player = playerlib.getPlayer(userid)
	if player.isdead == 1 and player.team > 1:
		cstrike.respawn(userid)