import es
import gamethread
import keymenulib
import langlib
import playerlib
import popuplib

def load():
	create_popup()

def create_popup():
	text = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2010/language/referee/popup_admin_referee_warn.ini")

	popup = popuplib.create("sm_popup_admin_referee_warn")

	line = "SOCCER MOD %s" % (text("title"))
	popup.addline(line)

	popup.addline(" ")

	number = 1
	while (number < 8):
		value = "sm_referee_warning_%s" % (number)
		warning = es.ServerVar(value)

		tokens = {}
		tokens['warning'] = warning
		line = "->%s. %s" % (number, text("warning", tokens))
		popup.addline(line)

		number += 1

	line = "->8. %s" % (text("custom"))
	popup.addline(line)

	popup.addline(" ")

	line = "->9. %s" % (text("back"))
	popup.addline(line)

	popup.addline(" ")

	line = "->0. %s" % (text("close"))
	popup.addline(line)

	popup.select(1, popup_warning)
	popup.select(2, popup_warning)
	popup.select(3, popup_warning)
	popup.select(4, popup_warning)
	popup.select(5, popup_warning)
	popup.select(6, popup_warning)
	popup.select(7, popup_warning)
	popup.select(8, popup_custom_warning)
	popup.submenu(9, "sm_popup_admin_referee")

def popup_warning(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	source_tv = es.ServerVar("tv_name")

	es.keygroupcreate("playerlist")

	myPlayerList = playerlib.getPlayerList("#all")
	for ply in myPlayerList:
		if ply.name != source_tv:
			es.keycreate("playerlist", ply.userid)
			es.keysetvalue("playerlist", ply.userid, "name", ply.name)

	if choice == 1:
		keymenu = keymenulib.create(name, "target", warning_1, "playerlist", "#keyvalue name", "#key", "Select a player")
	elif choice == 2:
		keymenu = keymenulib.create(name, "target", warning_2, "playerlist", "#keyvalue name", "#key", "Select a player")
	elif choice == 3:
		keymenu = keymenulib.create(name, "target", warning_3, "playerlist", "#keyvalue name", "#key", "Select a player")
	elif choice == 4:
		keymenu = keymenulib.create(name, "target", warning_4, "playerlist", "#keyvalue name", "#key", "Select a player")
	elif choice == 5:
		keymenu = keymenulib.create(name, "target", warning_5, "playerlist", "#keyvalue name", "#key", "Select a player")
	elif choice == 6:
		keymenu = keymenulib.create(name, "target", warning_6, "playerlist", "#keyvalue name", "#key", "Select a player")
	elif choice == 7:
		keymenu = keymenulib.create(name, "target", warning_7, "playerlist", "#keyvalue name", "#key", "Select a player")

	keymenu.backmenu("sm_popup_admin_referee_warn")
	keymenulib.send(name, userid)

	es.keygroupdelete("playerlist")

def warning_1(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_1")
	warning(userid, choice, warn)

def warning_2(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_2")
	warning(userid, choice, warn)

def warning_3(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_3")
	warning(userid, choice, warn)

def warning_4(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_4")
	warning(userid, choice, warn)

def warning_5(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_5")
	warning(userid, choice, warn)

def warning_6(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_6")
	warning(userid, choice, warn)

def warning_7(userid, choice, keymenuname):
	warn = es.ServerVar("sm_referee_warning_7")
	warning(userid, choice, warn)

def warning(userid, choice, warn):
	team = es.getplayerteam(choice)
	if team > 0:
		sound = es.ServerVar("sm_referee_sound_whistle")
		es.cexec_all("playgamesound", sound)

		name = es.getplayername(userid)
		target = es.getplayername(choice)

		message = "%s has warned %s for %s." % (name, target, warn)
		es.msg("#green", message)

		message = "You were warned by the referee for %s!" % (warn)

		es.menu(5, choice, message)
		player_tell(choice, message)
		gamethread.delayed(1, player_tell, (choice, message))
		gamethread.delayed(2, player_tell, (choice, message))
		gamethread.delayed(3, player_tell, (choice, message))
		gamethread.delayed(4, player_tell, (choice, message))

	popuplib.send("sm_popup_admin_referee_warn", userid)

def player_tell(userid, message):
	es.centertell(userid, message)

def popup_custom_warning(userid, choice, popupid):
	name = "sm_keymenu_%s" % (userid)
	if keymenulib.exists(name):
		keymenulib.delete(name)

	source_tv = es.ServerVar("tv_name")

	es.keygroupcreate("playerlist")

	myPlayerList = playerlib.getPlayerList("#all")
	for ply in myPlayerList:
		if ply.name != source_tv:
			es.keycreate("playerlist", ply.userid)
			es.keysetvalue("playerlist", ply.userid, "name", ply.name)

	keymenu = keymenulib.create(name, "target", custom_warning, "playerlist", "#keyvalue name", "#key", "Select a player")

	keymenu.backmenu("sm_popup_admin_referee_warn")
	keymenulib.send(name, userid)

	es.keygroupdelete("playerlist")

def custom_warning(userid, choice, popupid):
	team = es.getplayerteam(choice)
	if team > 0:
		steamid = es.getplayersteamid(userid)
		exists = es.exists("key", "sm_keygroup_set", steamid)
		if exists == 0:
			es.keycreate("sm_keygroup_set", steamid)

		es.keysetvalue("sm_keygroup_set", steamid, "setting_type", "referee_custom_warning")
		es.keysetvalue("sm_keygroup_set", steamid, "userid", choice)

		es.tell(userid, "#green", "Now type your warning in the chat or type !cancel to cancel.")

def player_say(event_var):
	steamid = es.getplayersteamid(event_var["userid"])

	exists = es.exists("key", "sm_keygroup_set", steamid)
	if exists == 1:
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "referee_custom_warning":
			if event_var["text"] != "!cancel":
				sound = es.ServerVar("sm_referee_sound_whistle")
				es.cexec_all("playgamesound", sound)

				choice = es.keygetvalue("sm_keygroup_set", steamid, "userid")
				name = es.getplayername(event_var["userid"])
				target = es.getplayername(choice)

				message = "%s has warned %s for %s." % (name, target, event_var["text"])
				es.msg("#green", message)

				message = "You were warned by the referee for %s!" % (event_var["text"])

				es.menu(5, choice, message)
				player_tell(choice, message)
				gamethread.delayed(1, player_tell, (choice, message))
				gamethread.delayed(2, player_tell, (choice, message))
				gamethread.delayed(3, player_tell, (choice, message))
				gamethread.delayed(4, player_tell, (choice, message))

				clear_key(event_var["userid"], steamid)
			else:
				clear_key(event_var["userid"], steamid)

def clear_key(userid, steamid):
	es.keydelete("sm_keygroup_set", steamid)
	popuplib.send("sm_popup_admin_referee_warn", userid)

def delete_popup():
	if popuplib.exists("sm_popup_admin_referee_warn"):
		popuplib.delete("sm_popup_admin_referee_warn")

def unload():
	delete_popup()